<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Validators\AuthValidator;
use Illuminate\Support\Facades\Hash;
use App\Managers\User\UserManager;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Session;
use App\Managers\SessionToken\SessionTokenManager;
use Illuminate\Support\Facades\Cookie;

class AuthController extends Controller
{
    public function p()
    {
        echo Hash::make('passwordabcdef45674');
    }
    public function __construct()
    {
        $this->helper = new Helper();
        $this->authValidator = new AuthValidator();
        $this->userManager = new UserManager();
        $this->sessionTokenManager = new SessionTokenManager();
      //  $this->userValidator = new AdminUserValidator();
    }
    public function register(Request $request)
    {
        if(!$request->all() || !$request->exists('data'))
        {
            return response()->json(['message' => 'No Input Found'], 400);
        }
        $data = $request->get('data');
        $data = $this->helper->changeSerialzeArrayValues($data, 'create');
        
        $validation = $this->authValidator->register($data);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        
        $data['dob'] = date("Y-m-d", strtotime($data['dob']));
        
        $data['confirmation_code'] = md5($this->helper->addUuid());
        $data['notification'] = $request->get('notification');
        $res = $this->userManager->register($data);
        if(!$res)
        {
            return response()->json(['message' => 'Something went wrong'], 500);
        }
       
        Mail::send('emails.confirm', ['email' => $data['email'], 'confirmation_code' => $data['confirmation_code'], 'url' => url('/'), 'name' => $data['name'], 'UUID' => $data['UUID']], function ($m) use ($data) {
            $m->from('info@realclubmanager.com', 'SUPPORTER 2.0');
            $m->to($data['email'], $data['name'])->subject('SUPPORTER 2.0 - Confirm your account!');
        });
        
        // check for failures
        if (Mail::failures()) {
            return response()->json(['User Registration Successful. Please contact our contact support to activate your account'], 500);
        }
        
        return response()->json(['User Registration Successful. Please check your mail for a confirmation link. <a data-href="' . url('/') . '/auth/confirm/' . $data['confirmation_code'] . '/' . $data['UUID'] . '">If you did not receive a mail, please click here for sending the mail again</a>'], 200);
    }
    
    public function login(Request $request)
    {
        if(!$request->all() || !$request->exists('data'))
        {
            return response()->json(['No Input Found'], 400);
        }
        
        $data = $request->get('data');
        $data = $this->helper->changeSerialzeArrayValues($data);
        
        $validation = $this->authValidator->login($data);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        
        if (Auth::attempt(['email' => $data['email'], 'password' => $data['password'] . 'abcdef45674', 'type' => 'general'])) {
            $user = $this->userManager->where('email', $data['email'])->first();
            if($user->active != 1)
            {
                return response()->json(['Account not confirmed. Please check spam also for the confirmation mail.! <a class="resend-email" data-href="' . url('/') . '/auth/confirm/' . $user->confirmation_code . '/' . $user->UUID . '/send/email">Resend the confirmation link.</a>'], 401);
                exit;
            }
//            Session::put('general', $user->UUID);
//            Session::put('type', 'general');
//            Session::put('name', $user->name);
//            Session::put('email', $user->email);
            
            $tokenData['UUID'] = $this->helper->addUUID();;
            $tokenData['user_id'] = $user->UUID;
            $tokenData['token'] = hash('sha256', rand(1000000,9999999) . date('dmyhis'));
            $tokenData['created_at'] = $tokenData['updated_at'] = date("Y-m-d H:i:s");
            
            $sessionTokenRes = $this->sessionTokenManager->where('token', $tokenData['token'])->first();
            if($sessionTokenRes)
            {
                return response()->json(['Something Went Wrong. Please Login Again'], 401);
                exit;
            }
            
            $res = $this->sessionTokenManager->insert($tokenData);
            if(!$res)
            {
                return response()->json(['Something Went Wrong. Please Login Again'], 401);
                exit;
            }
            
            //$response = new \Illuminate\Http\Response();
            Cookie::queue(Cookie::make('auth_code', $tokenData['token'], 100000));
            return response()->json(['Login Successful'], 200);
            exit;
        }
        
        
        return response()->json(['Email or Password does not match'], 400);
    }
    
    public function confirmAccountSendEmail(Request $request, $confirmationID, $userID)
    {
        if($confirmationID == '1')
        {
            return response()->json(['Something Went Wrong'], 500);
            exit;
        }
        
        $user = $this->userManager->where('confirmation_code', $confirmationID)->where('UUID', $userID)->first();
        if(!$user)
        {
            return response()->json(['User Not Found'], 404);
            exit;
        }
        Mail::send('emails.confirm', ['email' => $user['email'], 'confirmation_code' => $confirmationID, 'url' => url('/'), 'name' => $user['name'], 'UUID' => $userID], function ($m) use ($user) {
            $m->from('info@realclubmanager.com', 'SUPPORTER 2.0');
            $m->to($user['email'], $user['name'])->subject('SUPPORTER 2.0 - Confirm your account!');
        });
        
        
        return response()->json(['Mail Sent Successfully.'], 200);
    }
    
    public function confirmAccount($confirmationCode, $UUID)
    {
        $confirm = $this->userManager->confirmAccount($confirmationCode, $UUID);
        if(!$confirm)
        {
            die("Something went wrong. Please contact our support team at ");
        }
        
        return redirect('/')->withErrors(['Account Confirmation Successful. Please <a class="login_link">login</a>']);
    }
    
    public function logout(Request $request)
    {
        $request->session()->forget('general');
        $request->session()->forget('votes');
        Cookie::queue(
            Cookie::forget('auth_code')
        );
        return 1;
    }
    
    public function loginForm(Request $request)
    {
        if($request->session()->has('general'))
        {
            return redirect('/');
        }
        return view('auth/login');
    }
    
    public function resetPasswordLinkSent(Request $request)
    {
        if(!$request->exists('email'))
        {
            return response()->json(['Email is required'], 400);
            exit;
        }
        if(trim($request->get('email')) == '')
        {
            return response()->json(['Email is required'], 400);
            exit;
        }
        $email = $request->get('email');
        $user = $this->userManager->where('email', $email)->first();
        if($user)
        {
            $data['password_reset_code'] = md5($this->helper->addUuid());
            $res = $this->userManager->resetPasswordCode($data, $email);
            if(!$res)
            {
                return response()->json(['Something went wrong'], 500);
            }
            Mail::send('emails.reset', ['email' => $email, 'password_reset_code' => $data['password_reset_code'], 'url' => url('/'), 'UUID' => $user['UUID'], 'name' => $user['name']], function ($m) use ($data, $user) {
                $m->from('info@realclubmanager.com', 'SUPPORTER 2.0');
                $m->to($user['email'], $user['email'])->subject('SUPPORTER 2.0 - Reset Password');
            });
            
            if( count(Mail::failures()) > 0 ) {

                $errors = '';
                foreach(Mail::failures as $email_address) {
                    $errors.= " - $email_address <br />";
                 }
                 return response()->json([$errors], 500);
                exit;
             } 
            
            return response()->json(['Password Reset Link Sent Successfully'], 200);
            exit;
        }
        
        return response()->json(['Password Reset Link Sent Successfully'], 200);
        exit;
    }
    
    public function resetPassword(Request $request, $UUID, $ResetCode)
    {
        return view('auth/reset-password')->with('UUID', $UUID)->with('password_reset_code', $ResetCode);
    }
    
    public function resetPasswordAjax(Request $request,  $UUID, $ResetCode)
    {
        if($request->exists('data'))
        {
            $data = $request->get('data');
            $validation = $this->authValidator->resetPassword($data);
        
            if($validation)
            {
                return response()->json($validation['errors'], 400);
            }
            
            $where['password_reset_code'] = $ResetCode;
            $where['UUID'] = $UUID;
            if($ResetCode == 1 || $ResetCode == null || $UUID == null)
            {
                return response()->json(['User Not Found'], 400);
                exit;
            }
            $user = $this->userManager->where('password_reset_code', $ResetCode)->where('UUID', $UUID)->first();
            if(!$user)
            {
                return response()->json(['User Not Found'], 400);
                exit;
            }
            unset($data['confirmPassword']);
            $data['password_reset_code'] = 1;
            $data['password'] = Hash::make($data['password'] . 'abcdef45674');
            $res = $this->userManager->where('UUID', $UUID)->update($data);
            if(!$res)
            {
                return response()->json(['Something Went Wrong'], 500);
                exit;
            }
            
            return response()->json(['Password Reset Successful'], 200);
                exit;
        }
    }
    
    public function mainResetPassword(Request $request)
    {
        
        if(!$request->all() || !$request->exists('data'))
        {
            return response()->json(['No Input Found'], 400);
        }
        $data = $request->get('data');
        $validation = $this->authValidator->resetPasswordMain($data);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
       
        $data1['password'] = Hash::make($data['newPassword'] . 'abcdef45674');
        $update = $this->userManager->where('UUID', $request->session()->get('general'))->update($data1);
        if(!$update)
        {
            return response()->json(['Something went wrong'], 500);
        }
        
        return response()->json(['Password Updated'], 200);
    }
}